diff --git a/INSTALL b/INSTALL
index 54caf7c..2099840 100644
--- a/INSTALL
+++ b/INSTALL
@@ -1,13 +1,25 @@
-Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002 Free Software
-Foundation, Inc.
+Installation Instructions
+*************************
 
-   This file is free documentation; the Free Software Foundation gives
-unlimited permission to copy, distribute and modify it.
+Copyright (C) 1994-1996, 1999-2002, 2004-2013 Free Software Foundation,
+Inc.
+
+   Copying and distribution of this file, with or without modification,
+are permitted in any medium without royalty provided the copyright
+notice and this notice are preserved.  This file is offered as-is,
+without warranty of any kind.
 
 Basic Installation
 ==================
 
-   These are generic installation instructions.
+   Briefly, the shell command `./configure && make && make install'
+should configure, build, and install this package.  The following
+more-detailed instructions are generic; see the `README' file for
+instructions specific to this package.  Some packages provide this
+`INSTALL' file but do not implement all of the features documented
+below.  The lack of an optional feature in a given package is not
+necessarily a bug.  More recommendations for GNU packages can be found
+in *note Makefile Conventions: (standards)Makefile Conventions.
 
    The `configure' shell script attempts to guess correct values for
 various system-dependent variables used during compilation.  It uses
@@ -20,9 +32,9 @@ debugging `configure').
 
    It can also use an optional file (typically called `config.cache'
 and enabled with `--cache-file=config.cache' or simply `-C') that saves
-the results of its tests to speed up reconfiguring.  (Caching is
+the results of its tests to speed up reconfiguring.  Caching is
 disabled by default to prevent problems with accidental use of stale
-cache files.)
+cache files.
 
    If you need to do unusual things to compile the package, please try
 to figure out how `configure' could check whether to do them, and mail
@@ -32,30 +44,37 @@ some point `config.cache' contains results you don't want to keep, you
 may remove or edit it.
 
    The file `configure.ac' (or `configure.in') is used to create
-`configure' by a program called `autoconf'.  You only need
-`configure.ac' if you want to change it or regenerate `configure' using
-a newer version of `autoconf'.
+`configure' by a program called `autoconf'.  You need `configure.ac' if
+you want to change it or regenerate `configure' using a newer version
+of `autoconf'.
 
-The simplest way to compile this package is:
+   The simplest way to compile this package is:
 
   1. `cd' to the directory containing the package's source code and type
-     `./configure' to configure the package for your system.  If you're
-     using `csh' on an old version of System V, you might need to type
-     `sh ./configure' instead to prevent `csh' from trying to execute
-     `configure' itself.
+     `./configure' to configure the package for your system.
 
-     Running `configure' takes awhile.  While running, it prints some
-     messages telling which features it is checking for.
+     Running `configure' might take a while.  While running, it prints
+     some messages telling which features it is checking for.
 
   2. Type `make' to compile the package.
 
   3. Optionally, type `make check' to run any self-tests that come with
-     the package.
+     the package, generally using the just-built uninstalled binaries.
 
   4. Type `make install' to install the programs and any data files and
-     documentation.
-
-  5. You can remove the program binaries and object files from the
+     documentation.  When installing into a prefix owned by root, it is
+     recommended that the package be configured and built as a regular
+     user, and only the `make install' phase executed with root
+     privileges.
+
+  5. Optionally, type `make installcheck' to repeat any self-tests, but
+     this time using the binaries in their final installed location.
+     This target does not install anything.  Running this target as a
+     regular user, particularly if the prior `make install' required
+     root privileges, verifies that the installation completed
+     correctly.
+
+  6. You can remove the program binaries and object files from the
      source code directory by typing `make clean'.  To also remove the
      files that `configure' created (so you can compile the package for
      a different kind of computer), type `make distclean'.  There is
@@ -64,6 +83,16 @@ The simplest way to compile this package is:
      all sorts of other programs in order to regenerate files that came
      with the distribution.
 
+  7. Often, you can also type `make uninstall' to remove the installed
+     files again.  In practice, not all packages have tested that
+     uninstallation works correctly, even though it is required by the
+     GNU Coding Standards.
+
+  8. Some packages, particularly those that use Automake, provide `make
+     distcheck', which can by used by developers to test that all other
+     targets like `make install' and `make uninstall' work correctly.
+     This target is generally not run by end users.
+
 Compilers and Options
 =====================
 
@@ -75,7 +104,7 @@ for details on some of the pertinent environment variables.
 by setting variables in the command line or in the environment.  Here
 is an example:
 
-     ./configure CC=c89 CFLAGS=-O2 LIBS=-lposix
+     ./configure CC=c99 CFLAGS=-g LIBS=-lposix
 
    *Note Defining Variables::, for more details.
 
@@ -84,44 +113,89 @@ Compiling For Multiple Architectures
 
    You can compile the package for more than one kind of computer at the
 same time, by placing the object files for each architecture in their
-own directory.  To do this, you must use a version of `make' that
-supports the `VPATH' variable, such as GNU `make'.  `cd' to the
+own directory.  To do this, you can use GNU `make'.  `cd' to the
 directory where you want the object files and executables to go and run
 the `configure' script.  `configure' automatically checks for the
-source code in the directory that `configure' is in and in `..'.
+source code in the directory that `configure' is in and in `..'.  This
+is known as a "VPATH" build.
+
+   With a non-GNU `make', it is safer to compile the package for one
+architecture at a time in the source code directory.  After you have
+installed the package for one architecture, use `make distclean' before
+reconfiguring for another architecture.
 
-   If you have to use a `make' that does not support the `VPATH'
-variable, you have to compile the package for one architecture at a
-time in the source code directory.  After you have installed the
-package for one architecture, use `make distclean' before reconfiguring
-for another architecture.
+   On MacOS X 10.5 and later systems, you can create libraries and
+executables that work on multiple system types--known as "fat" or
+"universal" binaries--by specifying multiple `-arch' options to the
+compiler but only a single `-arch' option to the preprocessor.  Like
+this:
+
+     ./configure CC="gcc -arch i386 -arch x86_64 -arch ppc -arch ppc64" \
+                 CXX="g++ -arch i386 -arch x86_64 -arch ppc -arch ppc64" \
+                 CPP="gcc -E" CXXCPP="g++ -E"
+
+   This is not guaranteed to produce working output in all cases, you
+may have to build one architecture at a time and combine the results
+using the `lipo' tool if you have problems.
 
 Installation Names
 ==================
 
-   By default, `make install' will install the package's files in
-`/usr/local/bin', `/usr/local/man', etc.  You can specify an
-installation prefix other than `/usr/local' by giving `configure' the
-option `--prefix=PATH'.
+   By default, `make install' installs the package's commands under
+`/usr/local/bin', include files under `/usr/local/include', etc.  You
+can specify an installation prefix other than `/usr/local' by giving
+`configure' the option `--prefix=PREFIX', where PREFIX must be an
+absolute file name.
 
    You can specify separate installation prefixes for
 architecture-specific files and architecture-independent files.  If you
-give `configure' the option `--exec-prefix=PATH', the package will use
-PATH as the prefix for installing programs and libraries.
-Documentation and other data files will still use the regular prefix.
+pass the option `--exec-prefix=PREFIX' to `configure', the package uses
+PREFIX as the prefix for installing programs and libraries.
+Documentation and other data files still use the regular prefix.
 
    In addition, if you use an unusual directory layout you can give
-options like `--bindir=PATH' to specify different values for particular
+options like `--bindir=DIR' to specify different values for particular
 kinds of files.  Run `configure --help' for a list of the directories
-you can set and what kinds of files go in them.
+you can set and what kinds of files go in them.  In general, the
+default for these options is expressed in terms of `${prefix}', so that
+specifying just `--prefix' will affect all of the other directory
+specifications that were not explicitly provided.
+
+   The most portable way to affect installation locations is to pass the
+correct locations to `configure'; however, many packages provide one or
+both of the following shortcuts of passing variable assignments to the
+`make install' command line to change installation locations without
+having to reconfigure or recompile.
+
+   The first method involves providing an override variable for each
+affected directory.  For example, `make install
+prefix=/alternate/directory' will choose an alternate location for all
+directory configuration variables that were expressed in terms of
+`${prefix}'.  Any directories that were specified during `configure',
+but not in terms of `${prefix}', must each be overridden at install
+time for the entire installation to be relocated.  The approach of
+makefile variable overrides for each directory variable is required by
+the GNU Coding Standards, and ideally causes no recompilation.
+However, some platforms have known limitations with the semantics of
+shared libraries that end up requiring recompilation when using this
+method, particularly noticeable in packages that use GNU Libtool.
+
+   The second method involves providing the `DESTDIR' variable.  For
+example, `make install DESTDIR=/alternate/directory' will prepend
+`/alternate/directory' before all installation names.  The approach of
+`DESTDIR' overrides is not required by the GNU Coding Standards, and
+does not work on platforms that have drive letters.  On the other hand,
+it does better at avoiding recompilation issues, and works well even
+when some directory options were not specified in terms of `${prefix}'
+at `configure' time.
+
+Optional Features
+=================
 
    If the package supports it, you can cause programs to be installed
 with an extra prefix or suffix on their names by giving `configure' the
 option `--program-prefix=PREFIX' or `--program-suffix=SUFFIX'.
 
-Optional Features
-=================
-
    Some packages pay attention to `--enable-FEATURE' options to
 `configure', where FEATURE indicates an optional part of the package.
 They may also pay attention to `--with-PACKAGE' options, where PACKAGE
@@ -134,6 +208,50 @@ find the X include and library files automatically, but if it doesn't,
 you can use the `configure' options `--x-includes=DIR' and
 `--x-libraries=DIR' to specify their locations.
 
+   Some packages offer the ability to configure how verbose the
+execution of `make' will be.  For these packages, running `./configure
+--enable-silent-rules' sets the default to minimal output, which can be
+overridden with `make V=1'; while running `./configure
+--disable-silent-rules' sets the default to verbose, which can be
+overridden with `make V=0'.
+
+Particular systems
+==================
+
+   On HP-UX, the default C compiler is not ANSI C compatible.  If GNU
+CC is not installed, it is recommended to use the following options in
+order to use an ANSI C compiler:
+
+     ./configure CC="cc -Ae -D_XOPEN_SOURCE=500"
+
+and if that doesn't work, install pre-built binaries of GCC for HP-UX.
+
+   HP-UX `make' updates targets which have the same time stamps as
+their prerequisites, which makes it generally unusable when shipped
+generated files such as `configure' are involved.  Use GNU `make'
+instead.
+
+   On OSF/1 a.k.a. Tru64, some versions of the default C compiler cannot
+parse its `<wchar.h>' header file.  The option `-nodtk' can be used as
+a workaround.  If GNU CC is not installed, it is therefore recommended
+to try
+
+     ./configure CC="cc"
+
+and if that doesn't work, try
+
+     ./configure CC="cc -nodtk"
+
+   On Solaris, don't put `/usr/ucb' early in your `PATH'.  This
+directory contains several dysfunctional programs; working variants of
+these programs are available in `/usr/bin'.  So, if you need `/usr/ucb'
+in your `PATH', put it _after_ `/usr/bin'.
+
+   On Haiku, software installed for all users goes in `/boot/common',
+not `/usr/local'.  It is recommended to use the following options:
+
+     ./configure --prefix=/boot/common
+
 Specifying the System Type
 ==========================
 
@@ -149,14 +267,15 @@ type, such as `sun4', or a canonical name which has the form:
 
 where SYSTEM can have one of these forms:
 
-     OS KERNEL-OS
+     OS
+     KERNEL-OS
 
    See the file `config.sub' for the possible values of each field.  If
 `config.sub' isn't included in this package, then this package doesn't
 need to know the machine type.
 
    If you are _building_ compiler tools for cross-compiling, you should
-use the `--target=TYPE' option to select the type of system they will
+use the option `--target=TYPE' to select the type of system they will
 produce code for.
 
    If you want to _use_ a cross compiler, that generates code for a
@@ -186,9 +305,15 @@ them in the `configure' command line, using `VAR=value'.  For example:
 
      ./configure CC=/usr/local2/bin/gcc
 
-will cause the specified gcc to be used as the C compiler (unless it is
+causes the specified `gcc' to be used as the C compiler (unless it is
 overridden in the site shell script).
 
+Unfortunately, this technique does not work for `CONFIG_SHELL' due to
+an Autoconf limitation.  Until the limitation is lifted, you can use
+this workaround:
+
+     CONFIG_SHELL=/bin/bash ./configure CONFIG_SHELL=/bin/bash
+
 `configure' Invocation
 ======================
 
@@ -197,7 +322,14 @@ operates.
 
 `--help'
 `-h'
-     Print a summary of the options to `configure', and exit.
+     Print a summary of all of the options to `configure', and exit.
+
+`--help=short'
+`--help=recursive'
+     Print a summary of the options unique to this package's
+     `configure', and exit.  The `short' variant lists options used
+     only in the top level, while the `recursive' variant lists options
+     also present in any nested packages.
 
 `--version'
 `-V'
@@ -224,6 +356,15 @@ operates.
      Look for the package's source code in directory DIR.  Usually
      `configure' can determine that directory automatically.
 
+`--prefix=DIR'
+     Use DIR as the installation prefix.  *note Installation Names::
+     for more details, including other options available for fine-tuning
+     the installation locations.
+
+`--no-create'
+`-n'
+     Run the configure checks, but stop before creating any output
+     files.
+
 `configure' also accepts some other, not widely useful, options.  Run
 `configure --help' for more details.
-
diff --git a/Makefile.am b/Makefile.am
index 82dd543..205f406 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,20 +1,14 @@
-if HAVE_GTK
-target_rsvg_view = rsvg-view
-else
-target_rsvg_view =
-endif
+SUBDIRS = . gdk-pixbuf-loader tests doc
 
-SUBDIRS = . moz-plugin gdk-pixbuf-loader gtk-engine data tests doc
+NULL =
+BUILT_SOURCES =
 
 lib_LTLIBRARIES = librsvg-2.la
-bin_PROGRAMS = rsvg-convert $(target_rsvg_view)
-noinst_PROGRAMS = test-performance rsvg-dimensions
 
-man_MANS = rsvg.1
+bin_PROGRAMS = rsvg-convert
 
-if OS_WIN32
-else
-libm = -lm
+if HAVE_GTK
+bin_PROGRAMS += rsvg-view
 endif
 
 headers = \
@@ -24,18 +18,19 @@ headers = \
 enum_sources = \
 	librsvg-enum-types.h	\
 	librsvg-enum-types.c
+BUILT_SOURCES += $(enum_sources)
 
-librsvg_2_la_SOURCES = 		\
-	rsvg-affine.c		\
+librsvg_2_la_SOURCES = \
 	librsvg-features.c 	\
-	rsvg-bpath-util.c 	\
-	rsvg-bpath-util.h 	\
 	rsvg-css.c 		\
 	rsvg-css.h 		\
+	rsvg-compat.h		\
 	rsvg-defs.c 		\
 	rsvg-defs.h 		\
 	rsvg-image.c		\
 	rsvg-image.h		\
+	rsvg-io.c		\
+	rsvg-io.h		\
 	rsvg-paint-server.c 	\
 	rsvg-paint-server.h 	\
 	rsvg-path.c 		\
@@ -67,10 +62,41 @@ librsvg_2_la_SOURCES = 		\
 	rsvg-cairo-clip.c	\
 	rsvg.c			\
 	rsvg-gobject.c		\
-	rsvg-file-util.c
-
-librsvg_2_la_LDFLAGS = -version-info @VERSION_INFO@ -export-dynamic -no-undefined -export-symbols $(srcdir)/librsvg.def
-librsvg_2_la_LIBADD = $(LIBGSF_LIBS) $(LIBCROCO_LIBS) $(LIBRSVG_LIBS)
+	rsvg-file-util.c	\
+	rsvg-size-callback.c	\
+	rsvg-size-callback.h	\
+	rsvg-xml.c		\
+	rsvg-xml.h		\
+	rsvg.h			\
+	rsvg-cairo.h		\
+	librsvg-features.h 	\
+	librsvg-enum-types.h	\
+	$(NULL)
+
+librsvg_2_la_CPPFLAGS = \
+	-I$(top_srcdir) 			\
+	-I$(top_builddir) 			\
+	-DG_LOG_DOMAIN=\"librsvg\" 		\
+	-DLIBRSVG_DATADIR="\"$(datadir)\""	\
+	-DRSVG_DISABLE_DEPRECATION_WARNINGS	\
+	$(AM_CPPFLAGS)
+
+librsvg_2_la_CFLAGS = \
+	-DRSVG_COMPILATION	\
+	$(LIBRSVG_CFLAGS) 	\
+	$(AM_CFLAGS)
+
+librsvg_2_la_LDFLAGS = \
+	$(BSYMBOLIC_LDFLAG) \
+	-version-info @VERSION_INFO@ \
+	-export-dynamic \
+	-no-undefined \
+	-export-symbols-regex "^rsvg_.*" \
+	$(AM_LDFLAGS)
+
+librsvg_2_la_LIBADD = \
+	$(LIBRSVG_LIBS) 	\
+	$(LIBM)
 
 librsvgincdir = $(includedir)/librsvg-2/librsvg
 librsvginc_HEADERS = 	\
@@ -78,63 +104,76 @@ librsvginc_HEADERS = 	\
 	librsvg-features.h \
 	librsvg-enum-types.h
 
-INCLUDES =				\
-	-I$(top_srcdir) 		\
-	-I$(top_builddir) 		\
-	$(LIBGSF_CFLAGS)		\
-	$(LIBCROCO_CFLAGS)		\
-	$(LIBRSVG_CFLAGS) 		\
-	$(GTK_CFLAGS)			\
-	$(GDK_X11_CFLAGS)		\
-	-DG_LOG_DOMAIN=\"librsvg\" 	\
-	-DLIBRSVG_DATADIR="\"$(datadir)\""
-
-DEPS = $(top_builddir)/librsvg-2.la
-LDADDS =				\
-	$(LIBGSF_LIBS)			\
-	$(GLIB_LIBS)			\
-	$(LIBCROCO_LIBS)		\
-	$(LIBRSVG_LIBS) 		\
-	$(top_builddir)/librsvg-2.la
-
 bin_SCRIPTS=rsvg
 
-rsvg_convert_SOURCES=rsvg-convert.c
-rsvg_convert_LDFLAGS =
-rsvg_convert_DEPENDENCIES = $(DEPS)
-rsvg_convert_LDADD = $(LDADDS) $(libm)
+dist_man_MANS = rsvg-convert.1
+
+rsvg_convert_SOURCES = \
+	rsvg-convert.c \
+	rsvg-size-callback.c \
+	rsvg-size-callback.h \
+	$(NULL)
+
+rsvg_convert_CPPFLAGS = \
+	-I$(top_srcdir) 			\
+	-I$(top_builddir) 			\
+	-DLIBRSVG_DATADIR="\"$(datadir)\""	\
+	$(AM_CPPFLAGS)
+
+rsvg_convert_CFLAGS =\
+	$(RSVG_CONVERT_CFLAGS) \
+	$(AM_CFLAGS)
+
+rsvg_convert_LDFLAGS = $(AM_LDFLAGS)
 
-test_performance_SOURCES=test-performance.c
-test_performance_LDFLAGS =
-test_performance_DEPENDENCIES = $(DEPS)
-test_performance_LDADD = $(LDADDS) $(libm)
+rsvg_convert_LDADD = \
+	$(top_builddir)/librsvg-2.la	\
+	$(RSVG_CONVERT_LIBS) \
+	$(LIBM)
 
-rsvg_dimensions_SOURCES=rsvg-dimensions.c
-rsvg_dimensions_LDFLAGS =
-rsvg_dimensions_DEPENDENCIES = $(DEPS)
-rsvg_dimensions_LDADD = $(LDADDS) $(libm)
+rsvg_view_SOURCES = \
+	test-display.c \
+	rsvg-size-callback.h
+
+rsvg_view_CPPFLAGS = \
+	-I$(top_srcdir) 			\
+	-I$(top_builddir) 			\
+	-DLIBRSVG_DATADIR="\"$(datadir)\""	\
+	$(AM_CPPFLAGS)
+
+rsvg_view_CFLAGS =\
+	$(GTK_CFLAGS)		\
+	$(LIBRSVG_CFLAGS) 	\
+	$(AM_CFLAGS)
 
-rsvg_view_SOURCES = 		\
-	test-display.c
 rsvg_view_LDFLAGS =
-rsvg_view_DEPENDENCIES = $(DEPS)
-rsvg_view_LDADD = $(GTK_LIBS) $(GDK_X11_LIBS) $(libm) $(LDADDS)
+
+rsvg_view_LDADD = \
+	$(top_builddir)/librsvg-2.la \
+	$(GTK_LIBS)		\
+	$(LIBRSVG_LIBS)		\
+	$(GTHREAD_LIBS)		\
+	$(LIBM)
+
+if OS_WIN32
+rsvg_view_LDFLAGS += -mwindows
+endif # OS_WIN32
 
 EXTRA_DIST =				\
-	MAINTAINERS			\
+	librsvg.doap			\
 	AUTHORS				\
 	NEWS				\
 	TODO				\
 	COPYING.LIB 			\
-	librsvg.spec.in 		\
-	librsvg-2.0.pc.in 		\
-	librsvg-2.0-uninstalled.pc.in 	\
 	librsvg-zip.in 			\
-	rsvg.in				\
-	librsvg.def			\
-	$(man_MANS)			\
-	$(rsvg_view_SOURCES)		\
-	gtk-doc.make
+	gtk-doc.make			\
+	Rsvg-2.0.metadata		\
+	config.h.win32.in		\
+	config.h.win32			\
+	rsvg.symbols			\
+	glib-tap.mk			\
+	tap-driver.sh			\
+	tap-test
 
 CLEANFILES = \
 	$(enum_sources) \
@@ -146,15 +185,12 @@ CLEANFILES = \
 pkgconfigdir = $(libdir)/pkgconfig
 pkgconfig_DATA = librsvg-2.0.pc
 
-dist-hook: librsvg.spec
-	cp librsvg.spec $(distdir)
-
 librsvg-enum-types.h: s-enum-types-h
 	@true
 
 s-enum-types-h: $(headers) Makefile
-	( cd $(srcdir) && glib-mkenums \
-			--fhead "#ifndef __LIBRSVG_ENUM_TYPES_H__\n#define __LIBRSVG_ENUM_TYPES_H__\n\n#include <glib-object.h>\n\nG_BEGIN_DECLS\n" \
+	$(AM_V_GEN) ( cd $(srcdir) && $(GLIB_MKENUMS) \
+			--fhead "#if !defined (__RSVG_RSVG_H_INSIDE__) && !defined (RSVG_COMPILATION)\n#warning \"Including <librsvg/librsvg-enum-types.h> directly is deprecated.\"\n#endif\n\n#ifndef __LIBRSVG_ENUM_TYPES_H__\n#define __LIBRSVG_ENUM_TYPES_H__\n\n#include <glib-object.h>\n\nG_BEGIN_DECLS\n" \
 			--fprod "/* enumerations from \"@filename@\" */\n" \
 			--vhead "GType @enum_name@_get_type (void);\n#define RSVG_TYPE_@ENUMSHORT@ (@enum_name@_get_type())\n" 	\
 			--ftail "G_END_DECLS\n\n#endif /* __LIBRSVG_ENUM_TYPES_H__ */" \
@@ -167,8 +203,8 @@ librsvg-enum-types.c: s-enum-types-c librsvg-enum-types.h
 	@true
 
 s-enum-types-c: $(headers) Makefile
-	( cd $(srcdir) && glib-mkenums \
-			--fhead "#include \"librsvg-enum-types.h\"\n#include \"rsvg.h\"" \
+	$(AM_V_GEN) ( cd $(srcdir) && $(GLIB_MKENUMS) \
+			--fhead "#include \"rsvg.h\"" \
 			--fprod "\n/* enumerations from \"@filename@\" */" \
 			--vhead "GType\n@enum_name@_get_type (void)\n{\n  static GType etype = 0;\n  if (etype == 0) {\n    static const G@Type@Value values[] = {" 	\
 			--vprod "      { @VALUENAME@, \"@VALUENAME@\", \"@valuenick@\" }," \
@@ -179,3 +215,14 @@ s-enum-types-c: $(headers) Makefile
 	&& echo timestamp > $(@F)
 
 DISTCHECK_CONFIGURE_FLAGS = --enable-gtk-doc
+
+# ChangeLog generation
+
+ChangeLog:
+	$(AM_V_GEN) if test -d $(top_srcdir)/.git; then \
+		GIT_DIR="$(top_srcdir)/.git" git log --stat > $@; \
+	fi
+
+dist: ChangeLog
+
+.PHONY: ChangeLog
diff --git a/build/win32/vs9/math.h b/build/win32/vs9/math.h
new file mode 100644
index 0000000..f4f0c89
--- /dev/null
+++ b/build/win32/vs9/math.h
@@ -0,0 +1,39 @@
+/* librsvg - SVG rendering library
+ * Copyright (C) 2015 Chun-wei Fan <fanc999@yahoo.com.tw>
+ *
+ * Author: Chun-wei Fan <fanc999@yahoo.com.tw>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <float.h>
+
+/* include the system's math.h */
+#include <../include/math.h>
+#include <glib.h>
+
+#if (_MSC_VER < 1800)
+/* it seems of the supported compilers only
+ * MSVC does not have isnan(), but it does
+ * have _isnan() which does the same as isnan()
+ */
+#ifndef __MSVC_ISNAN_FALLBACK__
+#define __MSVC_ISNAN_FALLBACK__
+static inline gboolean
+isnan (double x)
+{
+  return _isnan (x);
+}
+#endif /* __MSVC_ISNAN_FALLBACK__ */
+#endif /* _MSC_VER < 1800 */
diff --git a/configure.in b/configure.in
index 2311e9e..ed07451 100644
--- a/configure.in
+++ b/configure.in
@@ -10,6 +10,8 @@ LIBXML_REQUIRED=2.4.7
 CAIRO_REQUIRED=1.2.0
 PANGOFT2_REQUIRED=1.2.0
 PANGOCAIRO_REQUIRED=1.10.0
+CROCO_REQUIRED=0.6.1
+GSF_REQUIRED=1.6.0
 
 AC_SUBST(GDK_PIXBUF_REQUIRED)
 AC_SUBST(GLIB_REQUIRED)
@@ -86,6 +88,9 @@ PKG_CHECK_MODULES(GLIB, \
 AC_SUBST(GLIB_LIBS)
 AC_SUBST(GLIB_CFLAGS)	
 
+GLIB_MKENUMS=`$PKG_CONFIG --variable=glib_mkenums glib-2.0`
+AC_SUBST(GLIB_MKENUMS)
+
 PKG_CHECK_MODULES(LIBRSVG, \
 	gdk-pixbuf-2.0 >= $GDK_PIXBUF_REQUIRED \
 	glib-2.0 >= $GLIB_REQUIRED \
@@ -94,7 +99,9 @@ PKG_CHECK_MODULES(LIBRSVG, \
 	pangocairo >= $PANGOCAIRO_REQUIRED \
 	cairo >= $CAIRO_REQUIRED \
 	cairo-png >= $CAIRO_REQUIRED \
-	fontconfig >= $FONTCONFIG_REQUIRED
+	libcroco-0.6 >= $CROCO_REQUIRED \
+	libgsf-1 >= $GSF_REQUIRED \
+	fontconfig >= $FONTCONFIG_REQUIRED \
 	freetype2)
 
 test_gio=true
@@ -107,6 +114,8 @@ PKG_CHECK_EXISTS(gio-2.0 >= $GIO_REQUIRED, [
 	test_gio=false
 ])
 
+PKG_CHECK_MODULES([RSVG_CONVERT],[gio-2.0 gio-unix-2.0 gdk-pixbuf-2.0 cairo pangocairo])
+
 AC_SUBST(LIBRSVG_LIBS)
 AC_SUBST(LIBRSVG_CFLAGS)
 
@@ -148,40 +157,6 @@ AC_SUBST([LIBRSVG_HAVE_SVGZ],[$svgz_define])
 
 dnl ===========================================================================
 
-LIBCROCO_CFLAGS=""
-LIBCROCO_LIBS=""
-LIBCROCOPKG=""
-
-test_croco=true
-AC_ARG_WITH(croco,[  --with-croco  Use libcroco for CSS parsing],[
-	if test "x$withval" = "xno"; then
-		test_croco=false
-	fi
-])
-if test "x$test_croco" = "xtrue"; then
-	PKG_CHECK_MODULES(LIBCROCO,[libcroco-0.6 >= 0.6.1], test_croco=true, test_croco=false)
-fi
-
-if test "x$test_croco" = "xtrue"; then
-        croco_define=1
-	LIBCROCO_CFLAGS="$LIBCROCO_CFLAGS -DHAVE_LIBCROCO=1"
-	LIBCROCOPKG="libcroco-0.6"
-else
-        croco_define=0
-	AC_MSG_WARN([LibCroco support disabled, as requested (Use --with-croco to enable)])
-        croco_warning="
-You are building without libcroco support. LibRSVG will not be able to handle embedded CSS, as is required per the SVG specification. If you are a library vendor or distributor, you are doing the world a disservice and should strongly consider shipping libcroco. Even KSVG needs libcroco now..."
-fi
-
-AC_SUBST(LIBCROCOPKG)
-AC_SUBST(LIBCROCO_CFLAGS)
-AC_SUBST(LIBCROCO_LIBS)
-
-AC_SUBST([CSS_SUPPORTED],[$test_croco])
-AC_SUBST([LIBRSVG_HAVE_CSS],[$croco_define])
-
-dnl ===========================================================================
-
 AC_CHECK_FUNCS(strtok_r basename)
 
 dnl ===========================================================================
@@ -243,18 +218,6 @@ fi
 AC_SUBST(GDK_X11_CFLAGS)
 AC_SUBST(GDK_X11_LIBS)
 
-AC_ARG_ENABLE(gtk-theme,
-    [  --enable-gtk-theme  Enable a RSVG based GTK+ theme engine [default=auto]],,
-    enable_gtk_theme=yes)
-
-if test "x$enable_gtk_theme" = "xyes"; then
-   if test "x$have_gtk" = "xno"; then
-      enable_gtk_theme=no;
-   fi
-fi
-
-AM_CONDITIONAL(ENABLE_GTK_ENGINE, test "x$enable_gtk_theme" = "xyes")
-
 AC_PATH_PROG(QUERYLOADERS, gdk-pixbuf-query-loaders, true)
 
 AC_ARG_ENABLE(pixbuf-loader,
@@ -272,36 +235,6 @@ fi
 AM_CONDITIONAL(ENABLE_PIXBUF_LOADER, test x$enable_pixbuf_loader = xyes)
 
 ##################################################
-##################################################
-
-MOZILLA_CFLAGS=
-build_mozilla_plugin=no
-
-test_mozilla_plugin=true
-AC_ARG_ENABLE(mozilla-plugin, [  --enable-mozilla-plugin  Build a Mozilla/Firefox SVG viewing plugin [default = auto]],
-			 test_mozilla_plugin="$enableval")
-
-if test "x$test_mozilla_plugin" != "xno"; then
-   if test -z "$MOZILLA_CONFIG"; then
-      AC_PATH_PROGS(MOZILLA_CONFIG, mozilla-config firefox-config xulrunner-config, no)
-   fi
-
-   if test "x$MOZILLA_CONFIG" != "xno"; then
-      MOZILLA_CFLAGS=`$MOZILLA_CONFIG --cflags plugin java`
-   else
-	PKG_CHECK_MODULES(MOZILLA, mozilla-plugin, build_mozilla_plugin=yes, 
-			[AC_MSG_WARN([mozilla-config not found. Mozilla/Netscape plugin will not be built])])
-   fi
-
-   if test "x$MOZILLA_CFLAGS" != "x"; then
-      build_mozilla_plugin=yes
-   fi
-fi
-
-AM_CONDITIONAL(WITH_MOZILLA,[test "x$build_mozilla_plugin" = "xyes"])
-AC_SUBST(MOZILLA_CFLAGS)
-
-##################################################
 # Checks for gtk-doc and docbook-tools
 ##################################################
 gtk_doc_installed=true
@@ -339,12 +272,7 @@ librsvg-2.0-uninstalled.pc
 librsvg-zip
 rsvg
 data/Makefile
-gtk-engine/Makefile
-gtk-engine/examples/Makefile
-gtk-engine/examples/bubble/Makefile
-gtk-engine/examples/bubble/gtk-2.0/Makefile
 gdk-pixbuf-loader/Makefile
-moz-plugin/Makefile
 tests/Makefile
 tests/pdiff/Makefile
 doc/Makefile
@@ -360,17 +288,10 @@ librsvg-$LIBRSVG_VERSION
 	compiler:                       ${CC}
 	
 	Build GdkPixbuf loader:         ${enable_pixbuf_loader}
-	Build theme engine:             ${enable_gtk_theme}
-	Build Netscape plugin:          ${build_mozilla_plugin}
 	Handle svgz files:              ${test_gsf}
 	Use GIO:                        ${test_gio}
-	Use libcroco for css parsing:   ${test_croco}
 "
 
-if test "x$croco_warning" != "x"; then
-   AC_MSG_RESULT([$croco_warning]);
-fi
-
 if test "x$gsf_warning" != "x"; then
    AC_MSG_RESULT([$gsf_warning]);
 fi
diff --git a/gdk-pixbuf-loader/io-svg.c b/gdk-pixbuf-loader/io-svg.c
index 5d24c78..91bbff9 100644
--- a/gdk-pixbuf-loader/io-svg.c
+++ b/gdk-pixbuf-loader/io-svg.c
@@ -233,17 +233,13 @@ fill_info (GdkPixbufFormat *info)
                 "image/svg-xml",
                 "image/vnd.adobe.svg+xml",
                 "text/xml-svg",
-#ifdef HAVE_SVGZ
                 "image/svg+xml-compressed",
-#endif
                 NULL
         };
         static gchar *extensions[] = {
                 "svg",
-#ifdef HAVE_SVGZ
                 "svgz",
                 "svg.gz",
-#endif
                 NULL
         };
 
diff --git a/librsvg-2.0-uninstalled.pc.in b/librsvg-2.0-uninstalled.pc.in
index 214ee5a..37df60d 100644
--- a/librsvg-2.0-uninstalled.pc.in
+++ b/librsvg-2.0-uninstalled.pc.in
@@ -3,7 +3,7 @@ exec_prefix=@exec_prefix@
 libdir=@libdir@
 includedir=@includedir@
 
-svgz_supported=@SVGZ_SUPPORTED@
+svgz_supported=true
 css_supported=@CSS_SUPPORTED@
 
 Name: librsvg
diff --git a/librsvg-2.0.pc.in b/librsvg-2.0.pc.in
index 236bdef..cc8b684 100644
--- a/librsvg-2.0.pc.in
+++ b/librsvg-2.0.pc.in
@@ -3,7 +3,7 @@ exec_prefix=@exec_prefix@
 libdir=@libdir@
 includedir=@includedir@
 
-svgz_supported=@SVGZ_SUPPORTED@
+svgz_supported=true
 css_supported=@CSS_SUPPORTED@
 
 Name: librsvg
diff --git a/librsvg-features.c b/librsvg-features.c
index 621d4f0..5e083c2 100644
--- a/librsvg-features.c
+++ b/librsvg-features.c
@@ -1,7 +1,7 @@
-#include "librsvg-features.h"
+#include "rsvg.h"
 
 /* General initialization hooks */
-const unsigned int librsvg_major_version = LIBRSVG_MAJOR_VERSION,
-    librsvg_minor_version = LIBRSVG_MINOR_VERSION, librsvg_micro_version = LIBRSVG_MICRO_VERSION;
-
-const char *librsvg_version = LIBRSVG_VERSION;
+const guint librsvg_major_version = LIBRSVG_MAJOR_VERSION;
+const guint librsvg_minor_version = LIBRSVG_MINOR_VERSION;
+const guint librsvg_micro_version = LIBRSVG_MICRO_VERSION;
+const char librsvg_version[] = LIBRSVG_VERSION;
